
thunkify  = require 'thunkify'
fs        = require 'fs'
async     = require 'async'
path      = require 'path'
recursive = require 'jsondir'
mkdirp    = require 'mkdirp'
ncp       = require 'ncp'

###*
 * Single Methods
###
class Methods

  instance = null

  constructor: () ->
    if !instance then instance = this
    return instance

  readFile     : thunkify fs.readFile
  readDir      : thunkify fs.readdir
  asyncMap     : thunkify async.mapSeries
  writeFile    : thunkify fs.writeFile
  ncp          : thunkify ncp 
  mkdirp       : thunkify mkdirp
  basePath     : path.join __dirname,"../../../"
  recursiveDir : thunkify recursive.dir2json
  buildPath    : (file,dir) ->
    dir ?= @basePath
    path.join dir,file
    

module.exports = Methods